#ifdef GL_ES
precision highp float;
#endif
varying vec2 v_buttontexcoord;
varying vec2 v_texcoord;

uniform sampler2D s_buttonsampler;
uniform sampler2D s_sampler;

uniform vec4 u_frontcolor;
uniform vec4 u_shadowcolor;
uniform vec4 u_glosscolor;
uniform vec4 u_backcolor;

vec4 over(vec4 a, vec4 b) {
    return vec4(a.a * a.rgb + (1.0-a.a) * b.rgb, a.a+b.a*(1.0-a.a));
}
vec4 alpha(vec4 a, float f) {
	return vec4(a.xyz,a.w*f);
}

void main(void)
{
    vec4 c = texture2D(s_buttonsampler,v_buttontexcoord);
    vec4 front = alpha(u_frontcolor*texture2D(s_sampler,v_texcoord),c.z);
    vec4 gloss = alpha(u_glosscolor,c.x);
    vec4 shadow = alpha(u_shadowcolor,c.y);
    vec4 back = alpha(u_backcolor,c.w);
    gl_FragColor = over(gloss,over(shadow,over(front,back)));
}