#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_texcoord;
uniform sampler2D s_sampler;
uniform vec4 u_color;

void main()
{
	vec4 color = texture2D(s_sampler, v_texcoord);
	float mask = color.r;

	vec4 frontColor = vec4(vec3(0.5),1);
	vec4 borderColor = vec4(vec3(0.8),1);
	vec4 transparent = vec4(0);

	color = mix(transparent,borderColor,	smoothstep(0.4, 0.5, mask));
	color = mix(color,frontColor,			smoothstep(0.5, 0.55, mask));

	gl_FragColor = color * u_color;
}